'''
Created on 22.06.2012

@author: Jan Brohl <janbrohl@t-online.de>
@license: Simplified BSD License see scoutnet/license.txt
@copyright: Copyright (c) 2012, Jan Brohl <janbrohl@t-online.de>. All rights reserved.
'''
from simplerest.rest import JSON_REST
from simplerest.util import default_hook
import warnings

class ScoutnetREST(JSON_REST):
    def __init__(self, basispfad='https://www.scoutnet.de/api/0.2/', object_hook=default_hook):
        JSON_REST.__init__(self, basispfad, object_hook)

    def query(self, objektpfad, query=None, *args):
        """
        absetzten einer anfrage
        """
        if query is None:
            return self.get(objektpfad)
        qa = [query]
        if args:
            qa.append(args)
        return self.get(objektpfad, json=qa)


def ScoutnetAPI(basispfad='https://www.scoutnet.de/api/0.1/', object_hook=default_hook):
    warnings.warn("Use of pyscoutnet.rest.ScoutnetAPI is deprecated. Use pyscoutnet.rest.ScoutnetREST directly instead.", category=DeprecationWarning)
    return ScoutnetREST(basispfad, object_hook)
