# -*- coding: utf-8 -*-
'''
Created on 16.06.2012

@warning: Hochexperimentell!!!
@attention: manche strings werden vom server nicht vollständig übergeben
@author: Jan Brohl <janbrohl@t-online.de>
@license: Simplified BSD License see license.txt
@copyright: Copyright (c) 2012, Jan Brohl <janbrohl@t-online.de>. All rights reserved.
'''
import re
import htmlentitydefs
from rest.util import convert, geturl
dmu = re.DOTALL | re.MULTILINE | re.UNICODE
tbody = re.compile(u'<table .*?>(.*?)</table>', dmu)
tr = re.compile(u"\\s*<tr.*?>\\s*<th>\\{\\$(.*?)\\}</th>\\s*<td>(.*?)</td>\\s*</tr>\\s*", dmu)
detag = dict(("&%s;" % k, unichr(v)) for k, v in htmlentitydefs.name2codepoint.items())
tagre = re.compile(u"[&]\\S+?[;]", dmu)
vre = re.compile(u'\\s*(:?(?:<b>Array\\s*[(](?P<array>\\d+?)[)]\\s*</b>)|(:?(?P<quote>["]?)(?P<atom>.*)(?P=quote))|(?P<null><i>null</i>))\\s*', dmu)
kvre = re.compile(u"\\s*<b>(?P<name>.+?)</b>\\s*=>" + vre.pattern, dmu)


def to_unicode(s):
    return tagre.sub((lambda m: detag.get(m.group(), m.group())), s)


def scrape(seite):
    d = dict()
    body = tbody.search(seite).group(1)
    for row in tr.finditer(body):
        key = row.group(1)
        value = list(to_unicode(v).strip() for v in row.group(2).split("<br>"))
        d[key] = make_v(value)
    return d


def make_v(valuelist):
    m = vre.match(valuelist[0])
    if m.group("array"):
        l = int(m.group("array"))
        return  make_array(l, iter(valuelist[1:]))
    elif m.group("atom"):
        return convert(m.group("atom"))
    else:
        return None


def make_kv(iterator):
    s = iterator.next()
    m = kvre.match(s)
    k = convert(m.group("name"))
    if m.group("array"):
        l = int(m.group("array"))
        v = make_array(l, iterator)
    elif m.group("atom"):
        v = convert(m.group("atom"))
    else:
        v = None
    return k, v


def make_array(length, iterator):
    d = dict()
    while length:
        k, v = make_kv(iterator)
        d[k] = v
        length -= 1
    return d


def get(kalender_id):
    return geturl("http://kalender.scoutnet.de/2.0/show.php?id=%i&template=debug.tpl" % kalender_id)


def get_scrape(kalender_id):
    #print "lade"
    seite = get(kalender_id)
    #print "geladen"
    return scrape(seite)
